@REM puck-extendj launcher script
@REM
@REM Environment:
@REM JAVA_HOME - location of a JDK home dir (optional if java on path)
@REM CFG_OPTS  - JVM options (optional)
@REM Configuration:
@REM PUCK_EXTENDJ_config.txt found in the PUCK_EXTENDJ_HOME.
@setlocal enabledelayedexpansion

@echo off

if "%PUCK_EXTENDJ_HOME%"=="" set "PUCK_EXTENDJ_HOME=%~dp0\\.."

set "APP_LIB_DIR=%PUCK_EXTENDJ_HOME%\lib\"

rem Detect if we were double clicked, although theoretically A user could
rem manually run cmd /c
for %%x in (!cmdcmdline!) do if %%~x==/c set DOUBLECLICKED=1

rem FIRST we load the config file of extra options.
set "CFG_FILE=%PUCK_EXTENDJ_HOME%\PUCK_EXTENDJ_config.txt"
set CFG_OPTS=
if exist %CFG_FILE% (
  FOR /F "tokens=* eol=# usebackq delims=" %%i IN ("%CFG_FILE%") DO (
    set DO_NOT_REUSE_ME=%%i
    rem ZOMG (Part #2) WE use !! here to delay the expansion of
    rem CFG_OPTS, otherwise it remains "" for this loop.
    set CFG_OPTS=!CFG_OPTS! !DO_NOT_REUSE_ME!
  )
)

rem We use the value of the JAVACMD environment variable if defined
set _JAVACMD=%JAVACMD%

if "%_JAVACMD%"=="" (
  if not "%JAVA_HOME%"=="" (
    if exist "%JAVA_HOME%\bin\java.exe" set "_JAVACMD=%JAVA_HOME%\bin\java.exe"
  )
)

if "%_JAVACMD%"=="" set _JAVACMD=java

rem Detect if this java is ok to use.
for /F %%j in ('"%_JAVACMD%" -version  2^>^&1') do (
  if %%~j==java set JAVAINSTALLED=1
  if %%~j==openjdk set JAVAINSTALLED=1
)

rem BAT has no logical or, so we do it OLD SCHOOL! Oppan Redmond Style
set JAVAOK=true
if not defined JAVAINSTALLED set JAVAOK=false

if "%JAVAOK%"=="false" (
  echo.
  echo A Java JDK is not installed or can't be found.
  if not "%JAVA_HOME%"=="" (
    echo JAVA_HOME = "%JAVA_HOME%"
  )
  echo.
  echo Please go to
  echo   http://www.oracle.com/technetwork/java/javase/downloads/index.html
  echo and download a valid Java JDK and install before running puck-extendj.
  echo.
  echo If you think this message is in error, please check
  echo your environment variables to see if "java.exe" and "javac.exe" are
  echo available via JAVA_HOME or PATH.
  echo.
  if defined DOUBLECLICKED pause
  exit /B 1
)


rem We use the value of the JAVA_OPTS environment variable if defined, rather than the config.
set _JAVA_OPTS=%JAVA_OPTS%
if "!_JAVA_OPTS!"=="" set _JAVA_OPTS=!CFG_OPTS!

rem We keep in _JAVA_PARAMS all -J-prefixed and -D-prefixed arguments
rem "-J" is stripped, "-D" is left as is, and everything is appended to JAVA_OPTS
set _JAVA_PARAMS=
set _APP_ARGS=

:param_loop
call set _PARAM1=%%1
set "_TEST_PARAM=%~1"

if ["!_PARAM1!"]==[""] goto param_afterloop


rem ignore arguments that do not start with '-'
if "%_TEST_PARAM:~0,1%"=="-" goto param_java_check
set _APP_ARGS=!_APP_ARGS! !_PARAM1!
shift
goto param_loop

:param_java_check
if "!_TEST_PARAM:~0,2!"=="-J" (
  rem strip -J prefix
  set _JAVA_PARAMS=!_JAVA_PARAMS! !_TEST_PARAM:~2!
  shift
  goto param_loop
)

if "!_TEST_PARAM:~0,2!"=="-D" (
  rem test if this was double-quoted property "-Dprop=42"
  for /F "delims== tokens=1,*" %%G in ("!_TEST_PARAM!") DO (
    if not ["%%H"] == [""] (
      set _JAVA_PARAMS=!_JAVA_PARAMS! !_PARAM1!
    ) else if [%2] neq [] (
      rem it was a normal property: -Dprop=42 or -Drop="42"
      call set _PARAM1=%%1=%%2
      set _JAVA_PARAMS=!_JAVA_PARAMS! !_PARAM1!
      shift
    )
  )
) else (
  if "!_TEST_PARAM!"=="-main" (
    call set CUSTOM_MAIN_CLASS=%%2
    shift
  ) else (
    set _APP_ARGS=!_APP_ARGS! !_PARAM1!
  )
)
shift
goto param_loop
:param_afterloop

set _JAVA_OPTS=!_JAVA_OPTS! !_JAVA_PARAMS!
:run
 
set "APP_CLASSPATH=%APP_LIB_DIR%\fr.lip6.puck-extendj-1.1.jar;%APP_LIB_DIR%\fr.lip6.puck-java-1.1.jar;%APP_LIB_DIR%\fr.lip6.puck-core-1.1.jar;%APP_LIB_DIR%\fr.lip6.puck-gui-1.1.jar;%APP_LIB_DIR%\RagDoll.jar;%APP_LIB_DIR%\piccolo2d-swt-3.1-SNAPSHOT.jar;%APP_LIB_DIR%\piccolo2d-extras-3.1-SNAPSHOT.jar;%APP_LIB_DIR%\w3c-svg.jar;%APP_LIB_DIR%\piccolo2d-core-3.1-SNAPSHOT.jar;%APP_LIB_DIR%\org.scala-lang.scala-library-2.11.8.jar;%APP_LIB_DIR%\org.scalaz.scalaz-core_2.11-7.1.2.jar;%APP_LIB_DIR%\org.scala-lang.modules.scala-parser-combinators_2.11-1.0.4.jar;%APP_LIB_DIR%\org.scala-lang.modules.scala-xml_2.11-1.0.4.jar;%APP_LIB_DIR%\org.scalatest.scalatest_2.11-2.2.1.jar;%APP_LIB_DIR%\org.scala-lang.scala-reflect-2.11.8.jar;%APP_LIB_DIR%\org.scala-sbt.io_2.11-0.13.8.jar;%APP_LIB_DIR%\org.scala-sbt.control_2.11-0.13.8.jar;%APP_LIB_DIR%\org.scala-lang.scala-parser-combinators-2.11.0-M4.jar;%APP_LIB_DIR%\org.scala-lang.scala-swing-2.11.0-M7.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.xmlgraphics-commons-2.0.1.jar;%APP_LIB_DIR%\commons-io.commons-io-1.3.1.jar;%APP_LIB_DIR%\commons-logging.commons-logging-1.0.4.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-util-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-svg-dom-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-awt-util-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-css-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-ext-1.8.jar;%APP_LIB_DIR%\xml-apis.xml-apis-1.3.04.jar;%APP_LIB_DIR%\xml-apis.xml-apis-ext-1.3.04.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-dom-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-xml-1.8.jar;%APP_LIB_DIR%\xalan.xalan-2.7.0.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-parser-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-swing-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-anim-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-bridge-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-gvt-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-script-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-gui-util-1.8.jar;%APP_LIB_DIR%\org.apache.xmlgraphics.batik-svggen-1.8.jar;%APP_LIB_DIR%\org.apache.ant.ant-1.9.6.jar;%APP_LIB_DIR%\org.apache.ant.ant-launcher-1.9.6.jar"
set "APP_MAIN_CLASS=puck.Front"

if defined CUSTOM_MAIN_CLASS (
    set MAIN_CLASS=!CUSTOM_MAIN_CLASS!
) else (
    set MAIN_CLASS=!APP_MAIN_CLASS!
)

rem Call the application and pass all arguments unchanged.
"%_JAVACMD%" !_JAVA_OPTS! !PUCK_EXTENDJ_OPTS! -cp "%APP_CLASSPATH%" %MAIN_CLASS% !_APP_ARGS!

@endlocal


:end

exit /B %ERRORLEVEL%
